﻿// perifericos.js

(function(ext) {
    var device = null;
    var _rxBuf = [];
    var switchStatus = {
		On:1,
		Off:0
	};
	var levels = {
		HIGH:1,
		LOW:0
	};
	var estados = {
		prender:1,
		apagar:0,
    "mostrar cursor":1,
    "ocultar cursor":2,
    "mostrar blink":3,
    "ocultar blink":4
	};

	var values = {};
	var indexs = [];
	var startTimer = 0;
	var versionIndex = 0xFA;
	var responsePreprocessor = {};


ext.resetAll = function(){
  device.send([0xff, 0x55, 2, 0, 4]);
};
ext.runArduino = function(){
  responseValue();
};

/**************************************************************/
//LCD
  ext.LCDI2C_Begin = function(addr, cols, lines){
    deviceID = 101;
		runPackage(deviceID, 1, addr, cols, lines);
	};
  ext.LCDI2C_Print = function(line, col, frase){
    deviceID = 101;
    runPackage(deviceID, 2, line, col, frase.length, string2array(frase));
	};
  ext.LCDI2C_Backlight = function(estado){
    deviceID = 101;
    runPackage(deviceID, 3, typeof estado=="string"?estados[estado]:new Number(estado));
	};
  ext.LCDI2C_Clear = function(){
    deviceID = 101;
    runPackage(deviceID, 4);
	};
  ext.LCDI2C_Indicator = function(estado){
    deviceID = 101;
	  runPackage(deviceID, 5, typeof estado=="string"?estados[estado]:new Number(estado));
	};

//Matriz Led
  ext.LedMx_begin = function(dataPin, csPin, clkPin, nm){
    deviceID = 100;
    runPackage(deviceID, 1, dataPin, csPin, clkPin, nm);
	};
	ext.LedMx_brillo = function(v){
		runPackage(100, 2, v);
	};
	ext.LedMx_led = function(nm, pfila, pcolumna, estado){
		runPackage(100, 3, nm, pfila, pcolumna, typeof estado=="string"?estados[estado]:new Number(estado));
	};
	ext.LedMx_frase = function(frase, vel){
		runPackage(100, 4, vel, frase.length, string2array(frase));
	};
	ext.LedMx_cifra = function(v){
		runPackage(100, 5, v);
	};
	ext.LedMx_dosletras = function(le){
		runPackage(100, 6, le.length, string2array(le));
	};
	ext.LedMx_encender = function(){
		runPackage(100, 8);
	};
	ext.LedMx_apagar = function(){
		runPackage(100, 9);
	};
  ext.LedMx_borrar = function(){
		runPackage(100, 7);
	};

//Buzzer
  ext.Buzzer_beep = function(pin, duracion, repetir){
    deviceID = 102;
	   runPackage(deviceID,pin, short2array(duracion), repetir);
	};
//Led
  ext.Led_estado = function(pin, estado){
    deviceID = 103;
	   runPackage(deviceID, 1, pin, typeof estado=="string"?estados[estado]:new Number(estado));
	};
  ext.Led_parpadear = function(pin, duracion, repetir){
    deviceID = 103;
	   runPackage(deviceID, 2, pin, short2array(duracion), repetir);
	};
  //Control remoto NEC
    ext.KeyIR_get = function(pin){
      var deviceId = 104;
      getPackage(0, deviceId, pin);
  	};
/**************************************************************/





function sendPackage(argList, type){
  var bytes = [0xff, 0x55, 0, 0, type];
  for(var i=0;i<argList.length;++i){
    var val = argList[i];
    if(val.constructor == "[class Array]"){
      bytes = bytes.concat(val);
    }else{
      bytes.push(val);
    }
  }
  bytes[2] = bytes.length - 3;
  device.send(bytes);
}

function runPackage(){
  sendPackage(arguments, 2);
}
function getPackage(){
  var nextID = arguments[0];
  Array.prototype.shift.call(arguments);
  sendPackage(arguments, 1);
}

  var inputArray = [];
var _isParseStart = false;
var _isParseStartIndex = 0;
  function processData(bytes) {
  var len = bytes.length;
  if(_rxBuf.length>30){
    _rxBuf = [];
  }
  for(var index=0;index<bytes.length;index++){
    var c = bytes[index];
    _rxBuf.push(c);
    if(_rxBuf.length>=2){
      if(_rxBuf[_rxBuf.length-1]==0x55 && _rxBuf[_rxBuf.length-2]==0xff){
        _isParseStart = true;
        _isParseStartIndex = _rxBuf.length-2;
      }
      if(_rxBuf[_rxBuf.length-1]==0xa && _rxBuf[_rxBuf.length-2]==0xd && _isParseStart){
        _isParseStart = false;

        var position = _isParseStartIndex+2;
        var extId = _rxBuf[position];
        position++;
        var type = _rxBuf[position];
        position++;
        //1 byte 2 float 3 short 4 len+string 5 double
        var value;
        switch(type){
          case 1:{
            value = _rxBuf[position];
            position++;
          }
            break;
          case 2:{
            value = readFloat(_rxBuf,position);
            position+=4;
          /*  if(value<-255||value>1023){
              value = 0;
            }*/
          }
            break;
          case 3:{
            value = readInt(_rxBuf,position,2);
            position+=2;
          }
            break;
          case 4:{
            var l = _rxBuf[position];
            position++;
            value = readString(_rxBuf,position,l);
          }
            break;
          case 5:{
            value = readDouble(_rxBuf,position);
            position+=4;
          }
            break;
          case 6:
            value = readInt(_rxBuf,position,4);
            position+=4;
            break;
        }
        if(type<=6){
          responseValue(extId,value);
        }else{
          responseValue();
        }
        _rxBuf = [];
      }
    }
  }
  }
function readFloat(arr,position){
  var f= [arr[position],arr[position+1],arr[position+2],arr[position+3]];
  return (parseFloat(f)).toFixed(2);    // Ajuste a 2 decimales despues de la coma
}
function readInt(arr,position,count){
  var result = 0;
  for(var i=0; i<count; ++i){
    result |= arr[position+i] << (i << 3);
  }
  return result;
}
function readDouble(arr,position){
  return readFloat(arr,position);
}
function readString(arr,position,len){
  var value = "";
  for(var ii=0;ii<len;ii++){
    value += String.fromCharCode(_rxBuf[ii+position]);
  }
  return value;
}
  function appendBuffer( buffer1, buffer2 ) {
      return buffer1.concat( buffer2 );
  }

  // Extension API interactions
  var potentialDevices = [];
  ext._deviceConnected = function(dev) {
      potentialDevices.push(dev);

      if (!device) {
          tryNextDevice();
      }
  }

  function tryNextDevice() {
      // If potentialDevices is empty, device will be undefined.
      // That will get us back here next time a device is connected.
      device = potentialDevices.shift();
      if (device) {
          device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
      }
  }

  var watchdog = null;
  function deviceOpened(dev) {
      if (!dev) {
          // Opening the port failed.
          tryNextDevice();
          return;
      }
      device.set_receive_handler('arduino',processData);
  };

  ext._deviceRemoved = function(dev) {
      if(device != dev) return;
      device = null;
  };

  ext._shutdown = function() {
      if(device) device.close();
      device = null;
  };

  ext._getStatus = function() {
      if(!device) return {status: 1, msg: 'Board disconnected'};
      if(watchdog) return {status: 1, msg: 'Probing for Board'};
      return {status: 2, msg: 'Board connected'};
  }

  var descriptor = {};
ScratchExtensions.register('CSJB Periféricos', descriptor, ext, {type: 'serial'});
})({});
